-- Remove id column in foglamp.category_children

BEGIN TRANSACTION;

-- Drop existing index
DROP INDEX IF EXISTS foglamp.config_children_idx1;

-- Rename existing table into a temp one
ALTER TABLE foglamp.category_children RENAME TO category_children_old;

-- Create new table
CREATE TABLE foglamp.category_children (
       parent   character varying(255)  NOT NULL,
       child    character varying(255)  NOT NULL,
       CONSTRAINT config_children_pkey PRIMARY KEY(parent, child)
);

-- Copy data
INSERT INTO foglamp.category_children(parent, child) SELECT parent, child FROM foglamp.category_children_old;

-- Remote temp table
DROP TABLE IF EXISTS foglamp.category_children_old;

COMMIT;
